
// Manage reation and replay of paths for delta bot

// point
struct point
{
  int x,y,z,v;
};
#define MAX_POINTS 150
struct point points[ MAX_POINTS ];

int nextPoint = -1;
int numPoints = 0;


/////////////////////////////////////////////////////////////////////////
/////////////             LoopPath              /////////////////////////
//////////////////////////////////////////////////////////////////////////
boolean loopPath(){

  if( nextPoint+1 >= numPoints )
  {
    finitoPercorso = true;  // done all our work, will never run again
    return false;
  }
  Serial.print(nextPoint);
  Serial.print(" Xpoint:");
  Serial.print(points[nextPoint].x);
  Serial.print(" Ypoint:");
  Serial.print(points[nextPoint].y);
  Serial.print(" Zpoint:");
  Serial.println(points[nextPoint].z);
  Serial.print(" Vacuum:");
  Serial.println(points[nextPoint].v);



  nextPoint ++;
  moveTo(float(points[nextPoint].x), float(points[nextPoint].y), float(points[nextPoint].z), points[nextPoint].v);
  finitoPercorso=false;
  return true;
}

/////////////////////////////////////////////////////////////////////////
/////////////             buildPath            /////////////////////////
//////////////////////////////////////////////////////////////////////////
void buildPath()
{
  
 
  addPoint(0,0,-20,0);

  giroCarte(); 
   
  addPoint(0,0,-20,0);
  addPoint(0,0,0,0);
  }


/////////////////////////////////////////////////////////////////////////
/////////////             addPoint            /////////////////////////
//////////////////////////////////////////////////////////////////////////
void addPoint( int x, int y, int z, int v )
{
  if( numPoints + 1 >= MAX_POINTS )
    return;

  points[numPoints].x = x;
  points[numPoints].y = y;
  points[numPoints].z = z;
  points[numPoints].v = v;

  numPoints ++;
}


void giroCarte(){
  
   // preleva = take    deposita = put    punto = point     carta=card
   
    //preleva punto 2  - carta 2  // take from point 2 -  card 2
  addPoint(-70,0,-20,0);
  addPoint(-70,0,0,0);
  addPoint(-70,0,-20,1);
  //deposita punto 3 - carta 2 // put in the point 3 - card 2
  addPoint(0,70,-20,1);
  addPoint(0,70,-20,0);
  addPoint(0,70,-25,0);
  //preleva punto 1 - carta 1
  addPoint(0,-70,-20,0);
  addPoint(0,-70,0,0);
  addPoint(0,-70,-20,1);
  //deposita punto 2 - carta 1  
  addPoint(-70,0,-20,1);
  addPoint(-70,0,-20,0);
  addPoint(-70,0,-25,0);
  //preleva punto 3 - carta 2
  addPoint(0,70,-20,0);
  addPoint(0,70,0,0);
  addPoint(0,70,-20,1);
  //deposita punto 4 - carta 2 
  addPoint(70,0,-20,1);
  addPoint(70,0,-20,0);
  addPoint(70,0,-25,0);
  //preleva punt 2 - carta 1
  addPoint(-70,0,-20,0);
  addPoint(-70,0,0,0);
  addPoint(-70,0,-20,1);
  //deposita punto 3 - carta 1 
  addPoint(0,70,-20,1);
  addPoint(0,70,-20,0);
  addPoint(0,70,-25,0);
  //preleva punto 4 - carta 2
  addPoint(70,0,-20,0);
  addPoint(70,0,0,0);
  addPoint(70,0,-20,1);
  //deposita punto 1 - carta 2 
  addPoint(0,-70,-20,1);
  addPoint(0,-70,-20,0);
  addPoint(0,-70,-25,0);
  //preleva punto 3 - carta 1
  addPoint(0,70,-20,0);
  addPoint(0,70,0,0);
  addPoint(0,70,-20,1);
  //deposita punto 4 - carta 1 
  addPoint(70,0,-20,1);
  addPoint(70,0,-20,0);
  addPoint(70,0,-25,0);
  //preleva punto 1 - carta 2
  addPoint(0,-70,-20,0);
  addPoint(0,-70,0,0);
  addPoint(0,-70,-20,1);
  //deposita punto 2 - carta 2 
  addPoint(-70,0,-20,1);
  addPoint(-70,0,-20,0);
  addPoint(-70,0,-25,0);
  //preleva punto 4 - carta 1
  addPoint(70,0,-20,0);
  addPoint(70,0,0,0);
  addPoint(70,0,-20,1);
  //deposita punto 1 - carta 1 
  addPoint(0,-70,-20,1);
  addPoint(0,-70,-20,0);
  addPoint(0,-70,-25,0);
}

// make the X axe
void asseX(){
  for (int x=-9; x<10; x++)
  {
    int x1=x*10;
  addPoint(x1,0,-20,0);
  addPoint(x1,0,0,0);
  addPoint(x1,0,-20,0);
  }
}

//make the y axe
void asseY(){
  for (int y=-9; y<10; y++)
  {
    int y1=y*10;
  addPoint(0,y1,-20,0);
  addPoint(0,y1,0,0);
  addPoint(0,y1,-20,0);
  }
}




