#include <Servo.h>

float sensorRange = 0.0;

Servo servo1;
Servo servo2;
Servo servo3;
Servo servo4;
 
float correz=0; // correction due to robot geometry errors

float xPos = 0;  // x axis position
float yPos = 0; // y axis position
float zPos = 0; // z axis position, negative is up, positive is down. Delta bots are usually used up side down...

float t1;  //servo angle t for 'theta', 1 for servo 1
float t2;
float t3;

float currX = 0;
float currY = 0;
float currZ = 0;
float currT = millis();
int   currV = 0;
int   vChange=0;

float targetX = 0;
float targetY = 0;
float targetZ = 0;
int   targetV = 0;

float maxSpeed = 1.500; // mm / millisec -0.600 is good
float minSpeed = 0.001;
float currSpeed= 0;
float acceleration = 0.001; // mm / millisec / millisec - 0.002 keeps the current rig pretty calm, 0.004 starts to be wobbly

int result=0;
int data = 0;
boolean finitoPercorso = false;
boolean finitoMvto = false;

float cumula=0;


int u=0;

void setup(){
  servo1.attach(3);
  servo2.attach(6);
  servo3.attach(9);
  servo4.attach(10);

  delay(500);
 
  Serial.begin(38400);
  vacuumOFF();
  delay(500);
  
  // build the path 
  buildPath();
  // setup the motion values
  setupMotion();
  u=0;
}


void loop(){


  while (!finitoPercorso){
    boolean a=loopPath(); // make the path
    if (vChange==1)
      vacuum();  // start/stop the vacuum
    while (!finitoMvto){
      boolean b=loopMotion(); // make the single motion
    }
    finitoMvto=false;
  }
  delay(1000);
  
  
  servo1.detach();
  servo2.detach();
  servo3.detach();
  vacuumOFF();
  delay(500);
  servo4.detach();
  



}





